searchNodes=[{"doc":"SandboxRegistry We can use the sandbox registry to help create sandboxes for testing Sandboxes help us test by allow us to specify a mock that will be utilzed only for the specific test, allowing us to modify the return value of a specific function only in test. We can utilize this pattern by building around an adapter pattern, and using the sandbox in dev mode. Other ways to build this pattern include using a flag like sandbox? to enable sandbox mode and swap out calls to a sanbox Example Sandbox defmodule HTTPSandbox do @registry :http_sandbox @keys :unique def start_link do Registry . start_link ( keys : @keys , name : @registry ) end def set_get_responses ( tuples ) do tuples |&gt; Map . new ( fn { url , func } -&gt; { { :get , url } , func } end ) |&gt; then ( &amp; SandboxRegistry . register ( @registry , @state , &amp;1 , @keys ) ) |&gt; case do :ok -&gt; :ok { :error , :registry_not_started } -&gt; raise_not_started! ( ) end # Random sleep is needed to allow registry time to insert Process . sleep ( 50 ) end def get_response ( url , headers , options ) do func = find! ( :get , url ) func . ( url , headers , options ) end def find! ( method , url ) do case SandboxRegistry . lookup ( @registry , @state ) do { :ok , funcs } -&gt; find_response! ( funcs , method , url ) { :error , :pid_not_registered } -&gt; raise &quot;&quot;&quot; No functions registered for \#{ inspect ( self ( ) ) } Action: \#{ inspect ( action ) } URL: \#{ inspect ( url ) } ======= Use: ======= \#{ format_example ( action , url ) } === in your test === &quot;&quot;&quot; { :error , :registry_not_started } -&gt; raise &quot;&quot;&quot; Registry not started for \#{ inspect ( __MODULE__ ) } . Please add the line: \#{ inspect ( __MODULE__ ) } .start_link() to test_helper.exs for the current app. &quot;&quot;&quot; end end end Now we can use this in an HTTP module only in test by doing defmodule HTTP do @defaults_opts [ sandbox? : Mix . env ( ) === :test ] def get ( url , header , opts ) do opts = Keyword . merge ( @defaults_opts , opts ) if opts [ :sandbox? ] do HTTPSandbox . get_response ( url , headers , opts ) else make_get_request ( ) end end end Now in test we have the ability to mock out our get requests per test describe &quot;some get request&quot; do test &quot;test get /url&quot; do HTTPSandbox . set_get_responses ( [ { &quot;myurl.com&quot; , fn _url , _headers , _opts -&gt; { :ok , :whatever } end } ] ) assert { :ok , :whatever } === HTTP . get ( &quot;myurl.com&quot; , [ ] , [ ] ) end end Installation Available in Hex , the package can be installed by adding sandbox_registry to your list of dependencies in mix.exs : def deps do [ { :sandbox_registry , &quot;~&gt; 0.1.0&quot; } ] end The docs can be found at https://hexdocs.pm/sandbox_registry . Registers a map of state per test process, allowing us to build mock functionality on top Usage Start the registry in your test_helper.exs Registry . start_link ( keys : :duplicate , name : :some_registry ) :keys can be :duplicate or :unique (duplicate is faster, but you will overwrite state if setting it more than once) And the name/keys variables will need to be used in the following functions. Set the state in a setup block or within the test itself SandboxRegistry . register ( :some_registry , :my_context , %{ key1 : &quot;value&quot; , key2 : &quot; other_value } , :duplicate ) Access the state from anywhere in the application. SandboxRegistry functions are not available outside of test. if Mix . env ( ) === :test do def get_cache_value ( key ) :some_registry |&gt; SandboxRegistry . lookup ( :my_context ) |&gt; Map . fetch! ( key ) else defdelegate get_cache_value ( key ) , to : RealProductionCache end","ref":"SandboxRegistry.html","title":"SandboxRegistry","type":"module"},{"doc":"Get state for a pid or any of its ancestors","ref":"SandboxRegistry.html#lookup/2","title":"SandboxRegistry.lookup/2","type":"function"},{"doc":"Get state for a specific pid","ref":"SandboxRegistry.html#lookup/3","title":"SandboxRegistry.lookup/3","type":"function"},{"doc":"List all pids that have registered state for context","ref":"SandboxRegistry.html#lookup_pids/2","title":"SandboxRegistry.lookup_pids/2","type":"function"},{"doc":"Registers a map of state for a test process. keys are either :duplicate or :unique and must match the value that the registry was started with, i.e. Registry.start_link(keys: :duplicate, name: :some_registry) The with statement handles a couple of cases: 1.) If the Pid is already registered, update the map 2.) If update_value/3 fails with error, that means that the wrong process is attempting to update. This may be because a test case with the same PID was just killed, the registry hadn't been updated yet, and the current process with the same pid (because recycling is good for the earth) tried to access that stale entry. So retry!","ref":"SandboxRegistry.html#register/4","title":"SandboxRegistry.register/4","type":"function"},{"doc":"","ref":"SandboxRegistry.html#t:context/0","title":"SandboxRegistry.context/0","type":"type"},{"doc":"","ref":"SandboxRegistry.html#t:keys/0","title":"SandboxRegistry.keys/0","type":"type"},{"doc":"","ref":"SandboxRegistry.html#t:registry/0","title":"SandboxRegistry.registry/0","type":"type"},{"doc":"","ref":"SandboxRegistry.html#t:result/0","title":"SandboxRegistry.result/0","type":"type"},{"doc":"","ref":"SandboxRegistry.html#t:state/0","title":"SandboxRegistry.state/0","type":"type"}]